{-# LANGUAGE FlexibleContexts, TemplateHaskell, TypeFamilies, ScopedTypeVariables #-}
module TableFormat where

import Generics.BiGUL
import Generics.BiGUL.Interpreter
import Generics.BiGUL.TH
import Generics.BiGUL.Lib
import Data.List
import Data.Maybe
import GHC.Generics
import Debug.Trace
import Structure
import System.IO  
import Control.Monad
import Text.Regex
--import Format
import System.IO.Unsafe



dealsheet::[String]-> [Object]
dealsheet s = dealdata (head s) (tail s)

dealdata :: String -> [String] -> [Object]
dealdata colname records | length records == 0 = []
                         | otherwise = genObj colname (head records) : dealdata colname (tail records)

genObj :: String -> String -> Object
genObj s1 s2 = genkeyvalue ss1 ss2
                where ss1 = splitRegex (mkRegex ",") s1
                      ss2 = splitRegex (mkRegex ",") s2

genkeyvalue :: [String] -> [String] -> [(Key, Value)]
genkeyvalue ss1 ss2 | length ss1 /= length ss2 = error "given data is not legal"
                    | length ss1 == 0 = []
                    | otherwise = ((head ss1), Str (head ss2)) : genkeyvalue (tail ss1) (tail ss2)

readfiles :: [String]->[(Key, Value)]
readfiles names | length names == 0 = []
                | otherwise = ((head names), Arro objs):readfiles (tail names)
                  where 
                        handle = openFile ((head names)++".csv") ReadMode
                        contents = hGetContents (unsafePerformIO handle)
                        lineslist = lines (unsafePerformIO contents)
                        objs = dealsheet lineslist

showinnerobject :: [Object]->String
showinnerobject kvs = (showcolumn (head kvs) 1) ++ showallvalue kvs

showcolumn :: Object -> Int -> String --[(Key, Value)]
showcolumn kvs i | length kvs == 0 = "\n"
                 | i == 1 = fst (head kvs) ++ (showcolumn (tail kvs) 2)
                 | otherwise = "," ++ (fst (head kvs)) ++ (showcolumn (tail kvs) 2)

showallvalue :: [Object] -> String
showallvalue objs | length objs == 0 = ""
                  | otherwise = (showvalue (head objs) 1) ++ (showallvalue (tail objs) )


showvalue :: Object -> Int -> String
showvalue kvs i | length kvs == 0 = "\n"
                | i == 1 = getvaluestring (snd (head kvs)) ++ (showvalue (tail kvs) 2)
                | otherwise = "," ++ getvaluestring (snd (head kvs)) ++ (showvalue (tail kvs ) 2)

showobject2 :: [(Key, Value)] -> String
showobject2 kvs | length kvs == 0 = ""
                | otherwise = (fst k)++":\n"++ (showinnerobject (getvaluearrayobject (snd k))) ++"\n\n" ++ (showobject2 (tail kvs))
                  where k = head kvs

--showobject2 :: [(Key, Value)] -> [(String,String)]
--showobject2 kvs | length kvs == 0 = []
--                | otherwise = ((fst k), (showinnerobject (getvaluearrayobject (snd k)))) : showobject2 (tail kvs)
--                  where k = head kvs
                        



--readfile :: String -> [String]
--readfile str = do
--      handle <- openFile str ReadMode
--      contents <- hGetContents handle
--      let lineslist = lines contents
--      let lineslists = unsafePerformIO lineslist
--      return $ lineslists

testlalala = do  
        let obj = readfiles ["labs"]
        print obj
        print "\n\n"
        print (showobject2 obj)
--        writeFile "view.csv" (showobject2 obj)
--        writeFile "result.txt" "this is the json:\n"
--        appendFile "result.txt" (showobject obj 0)


